<script lang="ts">
  export let players: Player[];
  export let phase: Complete;

  function getRank(playerId: PlayerId) {
    const rankingsIdx = phase.rankings.findIndex((rankings) =>
      rankings.some((ranking) => ranking.player === playerId)
    );
    const betterRankings = phase.rankings.slice(0, rankingsIdx);
    return betterRankings
      .map((rankings) => rankings.length)
      .reduce((a, b) => a + b, 1);
  }

  function getTotal(playerId: PlayerId): number {
    return players.find((player) => player.id === playerId)?.score ?? NaN;
  }

  $: winners = phase.rankings[0];
</script>

<h2>
  {#if winners.length === 1}
    <gs6-user playerid={winners[0].player} />
    wins!
  {:else if winners.length === 2}
    <gs6-user playerid={winners[0].player} />
    and
    <gs6-user playerid={winners[1].player} />
    win!
  {:else if winners.length > 2}
    {#each winners.slice(0, winners.length - 1) as winner}
      <gs6-user playerid={winner.player} />,{' '}
    {/each} and
    <gs6-user playerid={winners[winners.length - 1].player} />
    win!
  {/if}
</h2>

<table>
  <thead>
    <tr>
      <th>Rank</th>
      <th>Player</th>
      <th>Base score</th>
      <th class="nowrap">Bonus <br /> <small>row + column + color</small></th>
      <th>Total</th>
      <th>Full rows <br /> <small>(tiebreaker)</small></th>
    </tr>
    <tr />
  </thead>
  <tbody>
    {#each phase.rankings as rankings}
      {#each rankings as ranking}
        <tr>
          <td>{getRank(ranking.player)}</td>
          <td class="player-name">
            <gs6-user userid={ranking.player} />
          </td>
          <td>{ranking.score}</td>
          <td class="nowrap">
            {ranking.bonus.row} + {ranking.bonus.column} + {ranking.bonus.color}
          </td>
          <td><strong> {getTotal(ranking.player)} </strong></td>
          <td>{ranking.rows}</td>
        </tr>
      {/each}
    {/each}
  </tbody>
</table>

<style>
  h2 {
    margin-top: 0.5em;
    margin-bottom: 1em;
  }
  .nowrap {
    white-space: nowrap;
  }
  table {
    border-collapse: collapse;
  }
  thead {
    border-bottom: solid 1px grey;
  }
  th,
  td {
    padding-left: 1em;
    padding-right: 1em;
  }
  thead th {
    padding-bottom: 0.5em;
  }
  th > small {
    font-weight: normal;
  }
  tbody > tr > td {
    padding-top: 0.5em;
    padding-bottom: 0.5em;
  }
  tbody > tr:first-child > td {
    padding-top: 1em;
  }
  .player-name {
    text-align: left;
  }
</style>
